local L = LibStub("AceLocale-3.0"):GetLocale("DebuffEnough")

--[[ ---------------------------------------------------------------------------
	 Data table format:
	 	spellName = {
	 		slot = "",
	 		class = "",
	 		creatureType = "",
	 		curse = bool,
	 		requiresTalentTab = n,
	 		requiresTalentNum = n,
	 		improvedByTalentTab = n,
	 		improvedByTalentNum = n,
	 		amountPerTalentPoint = n,
	 		percentagePerTalentPoint = n,
	 		levelForNewRank = {},
	 		amountAtRank = {},
	 	},
----------------------------------------------------------------------------- ]]

DebuffEnough.debuffs = {
		-- Expose Armor
		[GetSpellInfo(48669)] = {
			slot = L["Armor (Major)"],
			class = "ROGUE",
			levelForNewRank = {14, 26, 36, 46, 56, 66, 77},
			amountAtRank = {90, 180, 270, 360, 450, 520, 785},
		},
		-- Sunder Armor
		[GetSpellInfo(47467)] = {
			slot = L["Armor (Major)"],
			class = "WARRIOR",
			levelForNewRank = {10, 22, 34, 46, 58, 67, 77},
			amountAtRank = {90, 180, 270, 360, 450, 520, 785},
		},
		-- Acid Spit
		[GetSpellInfo(55754)] = {
			slot = L["Armor (Major)"],
			class = "HUNTER",
			creatureType = L["Worm"],
			requiresTalentTab = 1,
	 		requiresTalentNum = 26, -- Beast Mastery
	 		amountPerTalentPoint = 1,
			levelForNewRank = {1, 16, 32, 48, 64, 80},
			amountAtRank = {10, 120, 250, 360, 520, 785},
		},
		-- Curse of Recklessness
		[GetSpellInfo(57595)] = {
			slot = L["Armor (Minor)"],
			class = "WARLOCK",
			curse = true,
			levelForNewRank = {14, 28, 42, 56, 69, 79},
			amountAtRank = {175, 285, 395, 505, 610, 1260},
		},
		-- Faerie Fire
		[GetSpellInfo(48476)] = {
			slot = L["Armor (Minor)"],
			class = "DRUID",
			levelForNewRank = {18, 30, 42, 54, 66, 76},
			amountAtRank = {175, 285, 395, 505, 610, 1260},
		},
		-- Sting
		[GetSpellInfo(56631)] = {
			slot = L["Armor (Minor)"],
			class = "HUNTER",
			creatureType = L["Wasp"],
			levelForNewRank = {1, 16, 32, 48, 64, 80},
			amountAtRank = {175, 285, 395, 505, 610, 1260},
		},
		-- Curse of Weakness
		[GetSpellInfo(50511)] = {
			slot = L["Attack Power"],
			class = "WARLOCK",
			curse = true,
	 		improvedByTalentTab = 1,
	 		improvedByTalentNum = 4, -- Frailty
	 		percentagePerTalentPoint = 10,
			levelForNewRank = {4, 12, 22, 32, 42, 52, 61, 69, 71},
			amountAtRank = {21, 41, 64, 82, 123, 163, 257, 350, 478},
		},
		-- Demoralizing Roar
		[GetSpellInfo(48560)] = {
			slot = L["Attack Power"],
			class = "DRUID",
			improvedByTalentTab = 2,
	 		improvedByTalentNum = 2, -- Feral Aggression
	 		percentagePerTalentPoint = 8,
			levelForNewRank = {10, 20, 32, 42, 52, 62, 71, 77},
			amountAtRank = {31, 51, 68, 103, 138, 220, 299, 408},
		},
		-- Demoralizing Shout
		[GetSpellInfo(47437)] = {
			slot = L["Attack Power"],
			class = "WARRIOR",
			improvedByTalentTab = 2,
	 		improvedByTalentNum = 4, -- Improved Demoralizing Shout
	 		percentagePerTalentPoint = 8,
			levelForNewRank = {14, 24, 34, 44, 54, 62, 70, 79},
			amountAtRank = {35, 55, 70, 105, 140, 220, 300, 418},
		},
		-- Mangle - Bear
		[GetSpellInfo(48564)] = {
			slot = L["Bleed Damage"],
			class = "DRUID",
	 		requiresTalentTab = 2,
	 		requiresTalentNum = 26,
	 		amountPerTalentPoint = 30,
		},
		-- Mangle - Cat
		[GetSpellInfo(48566)] = {
			slot = L["Bleed Damage"],
			class = "DRUID",
	 		requiresTalentTab = 2,
	 		requiresTalentNum = 26,
	 		amountPerTalentPoint = 30,
		},
		-- Trauma
		[GetSpellInfo(46855)] = {
			slot = L["Bleed Damage"],
			class = "WARRIOR",
			requiresTalentTab = 1,
	 		requiresTalentNum = 19,
	 		amountPerTalentPoint = 15,
		},
		-- Curse of Tongues
		[GetSpellInfo(11719)] = {
			slot = L["Cast Speed"],
			class = "WARLOCK",
			curse = true,
			levelForNewRank = {26,50},
			amountAtRank = {50,60},
		},
		-- Mind-numbing Poison
		[GetSpellInfo(5761)] = {
			slot = L["Cast Speed"],
			class = "ROGUE",
			levelForNewRank = {24},
			amountAtRank = {60},
		},
		-- Lava Breath
		[GetSpellInfo(58611)] = {
			slot = L["Cast Speed"],
			class = "HUNTER",
			creatureType = L["Core Hound"],
			requiresTalentTab = 1,
	 		requiresTalentNum = 26, -- Beast Mastery
	 		amountPerTalentPoint = 1,
			levelForNewRank = {1},
			amountAtRank = {50},
		},
		-- Slow
		[GetSpellInfo(31589)] = {
			slot = L["Cast Speed"],
			class = "MAGE",
			requiresTalentTab = 1,
	 		requiresTalentNum = 26,
	 		amountPerTalentPoint = 60,
		},
		-- Heart of the Crusader
		[GetSpellInfo(20337)] = {
			slot = L["Critical Strike Chance Taken"],
			class = "PALADIN",
			requiresTalentTab = 3,
	 		requiresTalentNum = 4,
			amountPerTalentPoint = 1,
		},
		-- Master Poisoner
		[GetSpellInfo(58410)] = {
			slot = L["Critical Strike Chance Taken"],
			class = "ROGUE",
			requiresTalentTab = 1,
	 		requiresTalentNum = 23,
			amountPerTalentPoint = 1,
		},
		-- Totem of Wrath
		[GetSpellInfo(30706)] = {
			slot = L["Critical Strike Chance Taken"],
			class = "SHAMAN",
			requiresTalentTab = 1,
	 		requiresTalentNum = 21,
			amountPerTalentPoint = 3,
		},
		-- Aimed Shot
		[GetSpellInfo(49050)] = {
			slot = L["Healing Taken"],
			class = "HUNTER",
			requiresTalentTab = 2,
	 		requiresTalentNum = 9,
			amountPerTalentPoint = 50,
		},
		-- Furious Attacks
		[GetSpellInfo(46911)] = {
			slot = L["Healing Taken"],
			class = "WARRIOR",
			requiresTalentTab = 2,
	 		requiresTalentNum = 21,
			amountPerTalentPoint = 25,
		},
		-- Mortal Strike
		[GetSpellInfo(47486)] = {
			slot = L["Healing Taken"],
			class = "WARRIOR",
			requiresTalentTab = 1,
	 		requiresTalentNum = 21,
			amountPerTalentPoint = 50,
		},
		-- Wound Poison
		[GetSpellInfo(13218)] = {
			slot = L["Healing Taken"],
			class = "ROGUE",
			levelForNewRank = {32},
			amountAtRank = {50},
		},
		-- Icy Touch
		[GetSpellInfo(49909)] = {
			slot = L["Melee Attack Speed Slow"],
			class = "DEATHKNIGHT",
	 		improvedByTalentTab = 2,
	 		improvedByTalentNum = 1, -- Improved Icy Touch
	 		amountPerTalentPoint = 2,
	 		levelForNewRank = {55},
	 		amountAtRank = {14},
		},
		-- Infected Wounds
		[GetSpellInfo(48485)] = {
			slot = L["Melee Attack Speed Slow"],
			class = "DRUID",
			requiresTalentTab = 2,
	 		requiresTalentNum = 24,
			amountPerTalentPoint = 20/3,
		},
		-- Judgements of the Just
		[GetSpellInfo(53696)] = {
			slot = L["Melee Attack Speed Slow"],
			class = "PALADIN",
			requiresTalentTab = 2,
	 		requiresTalentNum = 24,
			amountPerTalentPoint = 10,
		},
		-- Thunder Clap
		[GetSpellInfo(47502)] = {
			slot = L["Melee Attack Speed Slow"],
			class = "WARRIOR",
	 		improvedByTalentTab = 3,
	 		improvedByTalentNum = 3, -- Improved Thunder Clap
	 		amountPerTalentPoint = 10/3,
			levelForNewRank = {18},
	 		amountAtRank = {10},
		},
		-- Insect Swarm
		[GetSpellInfo(48468)] = {
			slot = L["Melee Hit Chance Reduction"],
			class = "DRUID",
			requiresTalentTab = 1,
	 		requiresTalentNum = 13,
			amountPerTalentPoint = 3,
		},
		-- Scorpid Sting
		[GetSpellInfo(3043)] = {
			slot = L["Melee Hit Chance Reduction"],
			class = "HUNTER",
			levelForNewRank = {22},
	 		amountAtRank = {3},
		},
		-- Blood Frenzy
		[GetSpellInfo(29859)] = {
			slot = L["Physical Vulnerability"],
			class = "WARRIOR",
			requiresTalentTab = 1,
	 		requiresTalentNum = 28,
			amountPerTalentPoint = 1,
		},
		-- Savage Combat
		[GetSpellInfo(58413)] = {
			slot = L["Physical Vulnerability"],
			class = "ROGUE",
			requiresTalentTab = 2,
	 		requiresTalentNum = 26,
			amountPerTalentPoint = 1,
		},
		-- Improved Scorch
		[GetSpellInfo(12873)] = {
			slot = L["Spell Critical Strike Chance"],
			class = "MAGE",
			requiresTalentTab = 2,
	 		requiresTalentNum = 11,
			amountPerTalentPoint = 2,
		},
		-- Winter's Chill
		[GetSpellInfo(28593)] = {
			slot = L["Spell Critical Strike Chance"],
			class = "MAGE",
			requiresTalentTab = 3,
	 		requiresTalentNum = 18,
			amountPerTalentPoint = 2,
		},
		-- Curse of the Elements
		[GetSpellInfo(47865)] = {
			slot = L["Spell Damage Taken"],
			class = "WARLOCK",
			curse = true,
			improvedByTalentTab = 1,
	 		improvedByTalentNum = 23, -- Malediction
	 		amountPerTalentPoint = 1,
			levelForNewRank = {32, 46, 60, 69, 78},
			amountAtRank = {6, 8, 10, 10, 10},
		},
		-- Earth and Moon
		[GetSpellInfo(48506)] = {
			slot = L["Spell Damage Taken"],
			class = "DRUID",
			requiresTalentTab = 1,
	 		requiresTalentNum = 27,
			amountPerTalentPoint = 13/3,
		},
		-- Ebon Plague
		[GetSpellInfo(51735)] = {
			slot = L["Spell Damage Taken"],
			class = "DEATHKNIGHT",
			requiresTalentTab = 3,
	 		requiresTalentNum = 27,
			amountPerTalentPoint = 13/3,
		},
		-- Improved Faerie Fire
		[GetSpellInfo(33602)] = {
			slot = L["Spell Hit Chance Taken"],
			class = "DRUID",
			requiresTalentTab = 1,
	 		requiresTalentNum = 20,
			amountPerTalentPoint = 1,
		},
		-- Misery
		[GetSpellInfo(33193)] = {
			slot = L["Spell Hit Chance Taken"],
			class = "PRIEST",
			requiresTalentTab = 3,
	 		requiresTalentNum = 22,
			amountPerTalentPoint = 1,
		},
}

DebuffEnough.slotSuffix = {
	[L["Armor (Major)"]] = " Armor",
	[L["Armor (Minor)"]] = " Armor",
	[L["Attack Power"]] = " AP",
	[L["Bleed Damage"]] = "%",
	[L["Cast Speed"]] = "%",
	[L["Critical Strike Chance Taken"]] = "%",
	[L["Healing Taken"]] = "%",
	[L["Melee Attack Speed Slow"]] = "%",
	[L["Melee Hit Chance Reduction"]] = "%",
	[L["Physical Vulnerability"]] = "%",
	[L["Spell Critical Strike Chance"]] = "%",
	[L["Spell Damage Taken"]] = "%",
	[L["Spell Hit Chance Taken"]] = "%",
}

DebuffEnough.debuffMap = {
	[GetSpellInfo(53408)] = GetSpellInfo(53696), -- Judgement of Wisdom  -> Judgements of the Just
	[GetSpellInfo(20271)] = GetSpellInfo(53696), -- Judgement of Light   -> Judgements of the Just
	[GetSpellInfo(53407)] = GetSpellInfo(53696), -- Judgement of Justice -> Judgements of the Just
	[GetSpellInfo(3408)]  = GetSpellInfo(58410), -- Crippling Poison     -> Master Poisoner
	[GetSpellInfo(41190)] = GetSpellInfo(58410), -- Mind-numbing Poison  -> Master Poisoner
	[GetSpellInfo(13218)] = GetSpellInfo(58410), -- Wound Poison         -> Master Poisoner
	[GetSpellInfo(2823)]  = GetSpellInfo(58410), -- Deadly Poison        -> Master Poisoner
	[GetSpellInfo(48475)] = GetSpellInfo(48476), -- Faerie Fire (Feral)  -> Faerie Fire
}

-- now check proper data consistency
for _,spellData in pairs(DebuffEnough.debuffs) do
	
	assert(spellData.slot)
	assert(spellData.class)
		
	if (spellData.requiresTalentTab) then assert(spellData.requiresTalentNum) end
	if (spellData.requiresTalentNum) then assert(spellData.requiresTalentTab) end
	if (spellData.improvedByTalentTab) then assert(spellData.improvedByTalentNum) end
	if (spellData.improvedByTalentNum) then assert(spellData.improvedByTalentTab) end
	
	if (spellData.levelForNewRank) then assert(spellData.amountAtRank) end
	if (spellData.amountAtRank) then assert(spellData.levelForNewRank) end
	if (spellData.levelForNewRank) then assert(#spellData.levelForNewRank == #spellData.amountAtRank) end
	
	if (spellData.requiresTalentTab and not spellData.creatureType) then assert(not spellData.levelForNewRank) end
	if (spellData.improvedByTalentTab) then assert(spellData.levelForNewRank) end
	
	if (spellData.requiresTalentTab or spellData.improvedByTalentTab) then
		assert(spellData.amountPerTalentPoint or spellData.percentagePerTalentPoint)
	end
	
end